import classnames from "classnames";
const { Fragment  } = wp.element;
//import { blockAttributes } from './block';
const blockAttributes = {
	title: {
		type: 'string',
		default: 'Click Here',
	},
	description: {
		type: 'string',
	},
	url: {
		type: 'string',
	},
	alignment: {
		type: 'string',
		selector: 'a',
	},
	buttoncolor: {
		type: "string",
		default: '#ffffff'
	},
	buttontextcolor: {
		type: "string",
		default: '#000000'
	},
	customSizeIcon: {
		default: 18+'px',
		type: 'int'
	},
	customSizeFont: {
		default: 18+'px',
		type: 'int'
	},
	iconColorCus: {
		type: 'string',
		default: '#000000'
	},
	iconName: {
		type: 'string',
		default: ''
	},
	iconCode: {
		type: 'string',
		default: ''
	},
	buttonSize: {
		type: 'string',
		default: 'small'
	},
	borderSize: {
		default: 1,
		type: 'number'
	},
	borderRadius: {
		default: 0,
		type: 'number'
	},
	bordercolor: {
		type: 'string',
		default: '#000000'
	},
	buttonHcolor: {
		type: 'string',
		default: '#000000'
	},
	buttontextHcolor: {
		type: 'string',
		default: '#ffffff'
	},
	hover: {
		type: 'boolean',
		default: false
	},
	iconPosition: {
		type: 'string',
		default: '0'
	},
	newtab: {
		type: "boolean",
		  default: false,
	},
	transparent: {
		type: "boolean",
		  default: false,
	},
	mediaID: {
		type: 'int'
	},
	mediaURL: {
		type: 'string',
		default: ''
	},
}
export default [

//save code before event tracking.
{
	attributes: blockAttributes,
	save: function( props ) {
		var attributes = props.attributes;
		var title = props.attributes.title;
		var alignment = props.attributes.alignment;
		var description = props.attributes.description;
		var url = props.attributes.url;
		var buttoncolor = props.attributes.buttoncolor;
		var buttontextcolor = props.attributes.buttontextcolor;
		const { customSizeIcon,
				customSizeFont,
				iconColorCus,
				iconName,
				iconCode,
				buttonSize,
				bordercolor,
				borderSize,
				borderRadius,
				buttontextHcolor,
				buttonHcolor,
				iconPosition,
				newtab,
				transparent,
				mediaID,
				mediaURL,
				
			 } = props.attributes;
		const {setAttributes} = props;
		let target="";

		let hoverEnterStyle = `this.style.cssText='color:${buttontextHcolor};background-color:${buttonHcolor};border-color:${bordercolor};border-radius:${borderRadius}px;border-width:${borderSize}px;'`;
		let hoverLeaveStyle = `this.style.cssText='color:${buttontextcolor};background-color:${buttoncolor};border-color:${bordercolor};border-radius:${borderRadius}px;border-width:${borderSize}px;'`;
		
		if(newtab == true){
			target= "_blank";
		}

		return (
		   	
			<div>
				<div style={{textAlign: alignment}}>
					
					<a className="button-block" href={url} target={target} rel="noopener noreferrer">
					
					<button style={{ backgroundColor: buttoncolor, color:buttontextcolor,borderColor: bordercolor,
		       	borderRadius:borderRadius,borderWidth: borderSize }} onmouseenter={hoverEnterStyle}
						onmouseleave={hoverLeaveStyle} className={buttonSize}>
					
						{iconPosition == "1" && (
						<Fragment>
							
							{iconName &&
								<Fragment>
									<span className={iconName}>
										<i className="material-icons" style={{
											...(iconColorCus ? {color : iconColorCus }:{}),
											...(customSizeIcon ? {fontSize : customSizeIcon}:{})
										}}>
											{iconName}
										</i>
									</span>
								</Fragment>
							}
							{mediaID &&
								<Fragment>
										<span className="mediaIcon">
											<img className="material-icons" src={mediaURL} width={customSizeIcon} />
										</span>
								</Fragment>
							}
							</Fragment>
						)}
					<span className={iconName ? "button-text" : ""} style={{
						...(customSizeFont ? {fontSize : customSizeFont}:{})
					}}>
					{title}
					</span>
					{iconPosition == "0" && (
							<Fragment>
						
							{iconName &&
								<Fragment>
									<span className={iconName}>
										<i className="material-icons" style={{
											...(iconColorCus ? {color : iconColorCus }:{}),
											...(customSizeIcon ? {fontSize : customSizeIcon}:{})
										}}>
											{iconName}
										</i>
									</span>
								</Fragment>
							}
							{mediaID &&
								<Fragment>
										<span className="mediaIcon">
											<img className="material-icons" src={mediaURL} width={customSizeIcon} />
										</span>
								</Fragment>
							}
							</Fragment>
						)}
						
					<br></br>	
					<span className={iconName ? "button-text" : ""}>	
						{description}
					</span>
					</button>
					</a>
				</div>
			</div>
		);
	},
},
{
	attributes: blockAttributes,
	save: function( props ) {
		var attributes = props.attributes;
		var title = props.attributes.title;
		var alignment = props.attributes.alignment;
		var description = props.attributes.description;
		var url = props.attributes.url;
		var buttoncolor = props.attributes.buttoncolor;
		var buttontextcolor = props.attributes.buttontextcolor;
		const { customSizeIcon,
			  customSizeFont,
			  iconColorCus,
			  iconName,
			  iconCode,
			  buttonSize,
			  bordercolor,
		      borderSize,
			  borderRadius,
			  buttontextHcolor,
		  	  buttonHcolor,
		  	  iconPosition,
		  	  newtab,
		  	  transparent,
		  	  mediaID,
		  	  mediaURL
			 } = props.attributes;
		const {setAttributes} = props;
		let target="";

		let hoverEnterStyle = "this.style.cssText='color:"+buttontextHcolor+";background-color:"+buttonHcolor+";'";
		let hoverLeaveStyle = "this.style.cssText='color:"+buttontextcolor+";background-color:"+buttoncolor+";'";
		
		if(newtab == true){
			target= "_blank";
		}

		return (
		   	
			<div>
				<div style={{textAlign: alignment}}>
					
					<a className="button-block" href={url} target={target} rel="noopener noreferrer">
					
					<button style={{ backgroundColor: buttoncolor, color:buttontextcolor,borderColor: bordercolor,
		       	borderRadius:borderRadius,borderWidth: borderSize }} onmouseenter={hoverEnterStyle}
						onmouseleave={hoverLeaveStyle} className={buttonSize}>
						<p style={{color:buttontextcolor}}>
						{iconPosition == "1" && (
						<Fragment>
							
							{iconName &&
								<Fragment>
									<span className={iconName}>
										<i className="material-icons" style={{
											...(iconColorCus ? {color : iconColorCus }:{}),
											...(customSizeIcon ? {fontSize : customSizeIcon}:{})
										}}>
											{iconName}
										</i>
									</span>
								</Fragment>
							}
							{mediaID &&
								<Fragment>
										<span className="mediaIcon">
											<img className="material-icons" src={mediaURL} width={customSizeIcon} />
										</span>
								</Fragment>
							}
							</Fragment>
						)}
					<span className={iconName ? "button-text" : ""} style={{
						...(customSizeFont ? {fontSize : customSizeFont}:{})
					}}>
					{title}
					</span>
					{iconPosition == "0" && (
							<Fragment>
						
							{iconName &&
								<Fragment>
									<span className={iconName}>
										<i className="material-icons" style={{
											...(iconColorCus ? {color : iconColorCus }:{}),
											...(customSizeIcon ? {fontSize : customSizeIcon}:{})
										}}>
											{iconName}
										</i>
									</span>
								</Fragment>
							}
							{mediaID &&
								<Fragment>
										<span className="mediaIcon">
											<img className="material-icons" src={mediaURL} width={customSizeIcon} />
										</span>
								</Fragment>
							}
							</Fragment>
						)}
						</p>
						
					<span className={iconName ? "button-text" : ""}>	
						{description}
					</span>
					</button>
					</a>
				</div>
			</div>
		);
	},
},

{
	attributes: blockAttributes,
	save: function( props ) {
		var attributes = props.attributes;
		var title = props.attributes.title;
		var alignment = props.attributes.alignment;
		var description = props.attributes.description;
		var url = props.attributes.url;
		var buttoncolor = props.attributes.buttoncolor;
		var buttontextcolor = props.attributes.buttontextcolor;
		const { customSizeIcon,
			  customSizeFont,
			  iconColorCus,
			  iconName,
			  iconCode,
			  buttonSize,
			  bordercolor,
		      borderSize,
			  borderRadius,
			  buttontextHcolor,
		  	  buttonHcolor,
		  	  iconPosition,
		  	  newtab,
		  	  mediaID,
		  	  mediaURL
			 } = props.attributes;
		const {setAttributes} = props;
		let target="";
		let hoverEnterStyle = "this.style.cssText='color:"+buttontextHcolor+";background-color:"+buttonHcolor+";'";
		let hoverLeaveStyle = "this.style.cssText='color:"+buttontextcolor+";background-color:"+buttoncolor+";'";
		console.log("newtab",newtab);
		if(newtab == true){
			target= "_blank";
		}
		

		return (
		   	
			<div>
				<div style={{textAlign: alignment}}>
					
					<a className="button-block" href={url} target={target} rel="noopener noreferrer">
					
					<button style={{ backgroundColor: buttoncolor, color:buttontextcolor,borderColor: bordercolor,
		       	borderRadius:borderRadius,borderWidth: borderSize }} onmouseenter={hoverEnterStyle}
						onmouseleave={hoverLeaveStyle} className={buttonSize}>
						<p>
						{iconPosition == "1" && (
						<Fragment>
							
							{iconName &&
								<Fragment>
									<span>
										<i className="material-icons" style={{
											...(iconColorCus ? {color : iconColorCus }:{}),
											...(customSizeIcon ? {fontSize : customSizeIcon}:{})
										}}>
											{iconName}
										</i>
									</span>
								</Fragment>
							}
							{mediaID &&
								<Fragment>
										<span>
											<img className="material-icons" src={mediaURL} width={customSizeIcon} />
										</span>
								</Fragment>
							}
							</Fragment>
						)}
					<span className={iconName ? "button-text" : ""} style={{
						...(customSizeFont ? {fontSize : customSizeFont}:{})
					}}>
					{title}
					</span>
					{iconPosition == "0" && (
							<Fragment>
						
							{iconName &&
								<Fragment>
									<span>
										<i className="material-icons" style={{
											...(iconColorCus ? {color : iconColorCus }:{}),
											...(customSizeIcon ? {fontSize : customSizeIcon}:{})
										}}>
											{iconName}
										</i>
									</span>
								</Fragment>
							}
							{mediaID &&
								<Fragment>
										<span>
											<img className="material-icons" src={mediaURL} width={customSizeIcon} />
										</span>
								</Fragment>
							}
							</Fragment>
						)}
						</p>
						
					<span className={iconName ? "button-text" : ""}>	
						{description}
					</span>
					</button>
					</a>
				</div>
			</div>
		);
	},
},

{
	attributes: blockAttributes,
	save: function( props ) {
		var attributes = props.attributes;
		var title = props.attributes.title;
		var alignment = props.attributes.alignment;
		var description = props.attributes.description;
		var url = props.attributes.url;
		var buttoncolor = props.attributes.buttoncolor;
		var buttontextcolor = props.attributes.buttontextcolor;
		const { customSizeIcon,
			  iconColorCus,
			  iconName,
			  iconCode,
			  buttonSize,
			  bordercolor,
		      borderSize,
			  borderRadius,
			  buttontextHcolor,
		  	  buttonHcolor,
		  	  iconPosition,
		  	  newtab
			 } = props.attributes;
		const {setAttributes} = props;
		let target="";
		let hoverEnterStyle = "this.style.cssText='color:"+buttontextHcolor+";background-color:"+buttonHcolor+";'";
		let hoverLeaveStyle = "this.style.cssText='color:"+buttontextcolor+";background-color:"+buttoncolor+";'";
		console.log("newtab",newtab);
		if(newtab == true){
			target= "_blank";
		}
		

		return (
		   	
			<div>
				<div style={{textAlign: alignment}}>
					
					<a className="button-block" href={url} target={target}>
					
					<button style={{ backgroundColor: buttoncolor, color:buttontextcolor,borderColor: bordercolor,
		       	borderRadius:borderRadius,borderWidth: borderSize }} onmouseenter={hoverEnterStyle}
						onmouseleave={hoverLeaveStyle} className={buttonSize}>
						{iconPosition == "1" && (
						<Fragment>
						
							{iconName &&
								<Fragment>
									<span>
										<i className="material-icons" style={{
											...(iconColorCus ? {color : iconColorCus }:{}),
											...(customSizeIcon ? {fontSize : customSizeIcon}:{})
										}}>
											{iconName}
										</i>
									</span>
								</Fragment>
							}
							</Fragment>
						)}
					<span className={iconName ? "button-text" : ""}>
					
					{title}
					</span>
					{iconPosition == "0" && (
							<Fragment>
						
							{iconName &&
								<Fragment>
									<span>
										<i className="material-icons" style={{
											...(iconColorCus ? {color : iconColorCus }:{}),
											...(customSizeIcon ? {fontSize : customSizeIcon}:{})
										}}>
											{iconName}
										</i>
									</span>
								</Fragment>
							}
							</Fragment>
						)}
						<br/>
					<span className={iconName ? "button-text" : ""}>	
						{description}
					</span>
					</button>
					</a>
				</div>
			</div>
		);
	},
},

{
 attributes: blockAttributes,
 save: function( props ) {
		var attributes = props.attributes;
		var title = props.attributes.title;
		var alignment = props.attributes.alignment;
		var description = props.attributes.description;
		var url = props.attributes.url;
		var buttoncolor = props.attributes.buttoncolor;
		var buttontextcolor = props.attributes.buttontextcolor;
		const { customSizeIcon,
			  iconColorCus,
			  iconName,
			  iconCode,
			  buttonSize,
			  bordercolor,
		      borderSize,
			  borderRadius,
			  buttontextHcolor,
		  	  buttonHcolor
			 } = props.attributes;
		const {setAttributes} = props;

		let hoverEnterStyle = "this.style.cssText='color:"+buttontextHcolor+";background-color:"+buttonHcolor+";'";
		let hoverLeaveStyle = "this.style.cssText='color:"+buttontextcolor+";background-color:"+buttoncolor+";'";
		return (
		   	
			<div>
				<div style={{textAlign: alignment}}>
				
					<a className="button-block" href={url}>
					<button style={{ backgroundColor: buttoncolor, color:buttontextcolor,borderColor: bordercolor,
		       	borderRadius:borderRadius,borderWidth: borderSize }} onmouseenter={hoverEnterStyle}
						onmouseleave={hoverLeaveStyle} className={buttonSize}>
					{iconName &&
						<Fragment>
							<span>
								<i className="material-icons" style={{
									...(iconColorCus ? {color : iconColorCus }:{}),
									...(customSizeIcon ? {fontSize : customSizeIcon}:{})
								}}>
									{iconName}
								</i>
							</span>
						</Fragment>
					}
					<span className={iconName ? "button-text" : ""}>
					{title}<br/>{description}
					</span>
					</button>
					</a>
				</div>
			</div>
		);
	},

},

{
	attributes: blockAttributes,
	save: function( props ) {
		var attributes = props.attributes;
		var title = props.attributes.title;
		var alignment = props.attributes.alignment;
		var description = props.attributes.description;
		var url = props.attributes.url;
		var buttoncolor = props.attributes.buttoncolor;
		var buttontextcolor = props.attributes.buttontextcolor;
		const { customSizeIcon,
			  customSizeFont,
			  iconColorCus,
			  iconName,
			  iconCode,
			  buttonSize,
			  bordercolor,
		      borderSize,
			  borderRadius,
			  buttontextHcolor,
		  	  buttonHcolor,
		  	  iconPosition,
		  	  newtab,
		  	  mediaID,
		  	  mediaURL
			 } = props.attributes;
		const {setAttributes} = props;
		let target="";
		let hoverEnterStyle = "this.style.cssText='color:"+buttontextHcolor+";background-color:"+buttonHcolor+";'";
		let hoverLeaveStyle = "this.style.cssText='color:"+buttontextcolor+";background-color:"+buttoncolor+";'";
		console.log("newtab",newtab);
		if(newtab == true){
			target= "_blank";
		}
		

		return (
		   	
			<div>
				<div style={{textAlign: alignment}}>
					
					<a className="button-block" href={url} target={target} rel="noopener noreferrer">
					
					<button style={{ backgroundColor: buttoncolor, color:buttontextcolor,borderColor: bordercolor,
		       	borderRadius:borderRadius,borderWidth: borderSize }} onmouseenter={hoverEnterStyle}
						onmouseleave={hoverLeaveStyle} className={buttonSize}>
						<p>
						{iconPosition == "1" && (
						<Fragment>
							
							{iconName &&
								<Fragment>
									<span className={iconName}>
										<i className="material-icons" style={{
											...(iconColorCus ? {color : iconColorCus }:{}),
											...(customSizeIcon ? {fontSize : customSizeIcon}:{})
										}}>
											{iconName}
										</i>
									</span>
								</Fragment>
							}
							{mediaID &&
								<Fragment>
										<span className="mediaIcon">
											<img className="material-icons" src={mediaURL} width={customSizeIcon} />
										</span>
								</Fragment>
							}
							</Fragment>
						)}
					<span className={iconName ? "button-text" : ""} style={{
						...(customSizeFont ? {fontSize : customSizeFont}:{})
					}}>
					{title}
					</span>
					{iconPosition == "0" && (
							<Fragment>
						
							{iconName &&
								<Fragment>
									<span className={iconName}>
										<i className="material-icons" style={{
											...(iconColorCus ? {color : iconColorCus }:{}),
											...(customSizeIcon ? {fontSize : customSizeIcon}:{})
										}}>
											{iconName}
										</i>
									</span>
								</Fragment>
							}
							{mediaID &&
								<Fragment>
										<span className="mediaIcon">
											<img className="material-icons" src={mediaURL} width={customSizeIcon} />
										</span>
								</Fragment>
							}
							</Fragment>
						)}
						</p>
						
					<span className={iconName ? "button-text" : ""}>	
						{description}
					</span>
					</button>
					</a>
				</div>
			</div>
		);
	},
	
},
];